interface ICommand<I, R> {
    withRequest(request: I): ICommand<I, R>;
    execute(): R;
}

declare abstract class AbstractCommand<I, R> implements ICommand<I, R> {
    private i?;
    withRequest(request: I): ICommand<I, R>;
    execute(): R;
    protected validate(request?: I): void;
    protected abstract run(request?: I): R;
}

export { AbstractCommand, type ICommand };
